
/* Chrysalide - Outil d'analyse de fichiers binaires
 * ##FILE## - traduction d'instructions ARMv7
 *
 * Copyright (C) 2014 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


@title MOV (immediate)

@encoding(t1) {

    @half 0 0 1 0 0 Rd(3) imm8(8)

    @syntax <Rd> <const>

    @conv {

        Rd = Register(Rd)
        const = ZeroExtend(imm8, 8, 32)

    }

}

@encoding(T2) {

    @word 1 1 1 1 0 i(1) 0 0 0 1 0 S(1) 1 1 1 1 0 imm3(3) Rd(4) imm8(8)

    @syntax {S} ".W" <Rd> <const>

    @conv {

        S = SetFlags(S)
        Rd = Register(Rd)
        const = ThumbExpandImm_C(i:imm3:imm8, 0)

    }

    @rules {

        //if d IN {13,15} then UNPREDICTABLE;

    }

}

@encoding(T3) {

    @word 1 1 1 1 0 i(1) 1 0 0 1 0 0 imm4(4) 0 imm3(3) Rd(4) imm8(8)

    @syntax <Rd> <const>

    @conv {

        Rd = Register(Rd)
        const = ZeroExtend(imm4:i:imm3:imm8, 12, 32)

    }

    @rules {

        //if d IN {13,15} then UNPREDICTABLE;

    }

}

@encoding(A1) {

    @word cond(4) 0 0 1 1 1 0 1 S(1) 0 0 0 0 Rd(4) imm12(12)

    @syntax {S} {c} <Rd> <const>

    @conv {

        S = SetFlags(S)
        c = Condition(cond)
        Rd = Register(Rd)
        const = ARMExpandImm_C(imm12, 0)

    }

    @rules {

        if ((Rd == '1111') && (S == '1')) ; see SUBS PC, LR and related instructions (ARM)

    }

}

@encoding(A2) {

    @word cond(4) 0 0 1 1 0 0 0 0 imm4(4) Rd(4) imm12(12)

    @syntax "movw" {c} <Rd> <const>

    @conv {

        c = Condition(cond)
        Rd = Register(Rd)
        const = ZeroExtend(imm4:imm12, 16, 32)

    }

    @rules {

        //if d == 15 then UNPREDICTABLE;

    }

}
